<?php
namespace nur\b\coll;

use ArrayAccess;
use Countable;

/**
 * Interface IArray: un objet qui se comporte comme un array
 */
interface IArray extends ArrayAccess, Countable {
  function &array(): ?array;
  function count(): int;
  function keys(): array;

  /**
   * si cet objet implémente des méthodes dynamiques, indiquer si la méthode
   * spécifiée est valide
   */
  function _haveMethod(string $method): bool;
}
